﻿using System;
using System.Collections.Generic;
using Syncfusion.SfSchedule.XForms;
using Xamarin.Forms;

namespace ScheduleSample_test
{
	public class ScheduleViewModel
	{
	    public Command<Tuple<DateTime, DateTime>> SetDateRangeCommand { get; set; }
        public ScheduleAppointmentCollection ListOfAppointments { get; set; }
		List<string> currentDayMeetings;
		List<Color> color_collection;

		public ScheduleViewModel()
		{
		    SetDateRangeCommand = new Command<Tuple<DateTime, DateTime>>(SetDateRange, CanSetDateRange);
            ListOfAppointments = new ScheduleAppointmentCollection();
			InitializeDataForBookings();
            //BookingAppointments();
		   
		}

	    private void SetDateRange(Tuple<DateTime, DateTime> dates)
	    {
	        StartDate = dates.Item1.AddDays(10);
            BookingAppointments();
	    }

	    public DateTime StartDate { get; set; }

	    private bool CanSetDateRange(Tuple<DateTime, DateTime> arg)
	    {
	        return true;
	    }

	    #region BookingAppointments

		private void BookingAppointments()
		{
		    ListOfAppointments.Clear();
            Random randomTime = new Random();
			List<Point> randomTimeCollection = GettingTimeRanges();

			DateTime date;
			DateTime DateFrom = StartDate.AddDays(-10);
			DateTime DateTo = StartDate.AddDays(10);
			DateTime dateRangeStart = StartDate.AddDays(-3);
			DateTime dateRangeEnd = StartDate.AddDays(3);

			for (date = DateFrom; date < DateTo; date = date.AddDays(1))
			{
				if ((DateTime.Compare(date, dateRangeStart) > 0) && (DateTime.Compare(date, dateRangeEnd) < 0))
				{
					for (int AdditionalAppointmentIndex = 0; AdditionalAppointmentIndex < 3; AdditionalAppointmentIndex++)
					{
						ScheduleAppointment appointment = new ScheduleAppointment();
						int hour = (randomTime.Next((int)randomTimeCollection[AdditionalAppointmentIndex].X, (int)randomTimeCollection[AdditionalAppointmentIndex].Y));
						appointment.StartTime = new DateTime(date.Year, date.Month, date.Day, hour, 0, 0);
						appointment.EndTime = (appointment.StartTime.AddHours(1));
						appointment.Subject = currentDayMeetings[randomTime.Next(9)];
						appointment.Color = color_collection[randomTime.Next(9)];
						ListOfAppointments.Add(appointment);
					}
				}
				else
				{
					ScheduleAppointment appointment = new ScheduleAppointment();
					appointment.StartTime = new DateTime(date.Year, date.Month, date.Day, randomTime.Next(9, 11), 0, 0);
					appointment.EndTime = (appointment.StartTime.AddHours(1));
					appointment.Subject = currentDayMeetings[randomTime.Next(9)];
					appointment.Color = color_collection[randomTime.Next(9)];
					ListOfAppointments.Add(appointment);
				}
			}
		}

		#endregion BookingAppointments

		#region GettingTimeRanges

		private List<Point> GettingTimeRanges()
		{
			List<Point> randomTimeCollection = new List<Point>();
			randomTimeCollection.Add(new Point(9, 11));
			randomTimeCollection.Add(new Point(12, 14));
			randomTimeCollection.Add(new Point(15, 17));

			return randomTimeCollection;
		}

		#endregion GettingTimeRanges

		#region InitializeDataForBookings

		private void InitializeDataForBookings()
		{
			currentDayMeetings = new List<string>();
			currentDayMeetings.Add("General Meeting");
			currentDayMeetings.Add("Plan Execution");
			currentDayMeetings.Add("Project Plan");
			currentDayMeetings.Add("Consulting");
			currentDayMeetings.Add("Performance Check");
			currentDayMeetings.Add("Yoga Therapy");
			currentDayMeetings.Add("Plan Execution");
			currentDayMeetings.Add("Project Plan");
			currentDayMeetings.Add("Consulting");
			currentDayMeetings.Add("Performance Check");

			color_collection = new List<Color>();
			color_collection.Add(Color.FromHex("#FF339933"));
			color_collection.Add(Color.FromHex("#FF00ABA9"));
			color_collection.Add(Color.FromHex("#FFE671B8"));
			color_collection.Add(Color.FromHex("#FF1BA1E2"));
			color_collection.Add(Color.FromHex("#FFD80073"));
			color_collection.Add(Color.FromHex("#FFA2C139"));
			color_collection.Add(Color.FromHex("#FFA2C139"));
			color_collection.Add(Color.FromHex("#FFD80073"));
			color_collection.Add(Color.FromHex("#FF339933"));
			color_collection.Add(Color.FromHex("#FFE671B8"));
			color_collection.Add(Color.FromHex("#FF00ABA9"));

		}

		#endregion InitializeDataForBookings
	}
}



